# Amazon UK music scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("")

    i = string.find(source, "The item you indicated is ineligible for Amazon Marketplace selling.")

    if i != -1:
        return


    i = string.find(source, "sai-identify")

    if i != -1:
        source = searchForPlus(source, "sai-identify")
        i = string.find(source, "/ASIN/")
        source = source[i-50:]
        source = searchForPlus(source, "<a href=")
        i = string.find(source, ">")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "id=\"atfResults\"")

    if i != -1:
        source = searchForPlus(source, "id=\"atfResults\"")
        i = string.find(source, "title=\"Audio CD\"")

        if i != -1:
            source = searchForPlus(source, "title=\"Audio CD\"")

        source = searchForPlus(source, " href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Main extraction
    titleartist = searchForPlus(source, "<title>")
    i = string.find(titleartist, "</title>")
    titleartist = stripText(titleartist[0:i])
    i = string.find(titleartist, ":")

    if i != -1:
        titleartist = stripText(titleartist[i+1:])
        i = string.find(titleartist, ":")

        if i != -1:
            titleartist = stripText(titleartist[0:i])
    


    # Find Image
    imageFound = 0
    image = ""
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        images = searchForPlus(source, "registerImage(\"original_image\"")
        images = searchForPlus(images, "\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                aw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                aw.setImage1(image)
            else:
                aw.setImage1(image)

            imageFound = 1


    # Find Image
    tag = "id=\"main_image_0\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    #if i == -1:
    #    tag = "<li class=\"image\n"
    #    i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                aw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                aw.setImage1(image)

            i = string.find(image, "_SY300_")

            if i != -1:
                large = string.replace(image, "_SY300_", "_SY500_")
                aw.setLargeImage1(large)
                aw.setImage1(image)
            else:
                aw.setImage1(image)

            imageFound = 1

    if aw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                aw.setLargeImage1(large)

                imageFound = 1


    if imageFound == 0:                    
        tag = "'colorImages'"

        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(images, "\n")
            images = stripText(images[0:i])
            i = string.find(images, "\"main\"")

            if i != -1:
                images = searchForPlus(images, "\"large\"")
                i = string.find(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                aw.setLargeImage1(image)

                images = searchForPlus(images, "\"main\"")
                i = string.find(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                image = string.replace(image, "PJautoripBadge,BottomRight,4,-40_", "")
                aw.setImage1(image)

                imageFound = 1


    if imageFound == 0:                    
        tag = "data-feature-name=\"coverArt\""

        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])
            image = string.replace(image, "PJStripe-Robin,TopLeft,0,0", "")
            aw.setImage1(image)
            image = string.replace(image, "_SS280_", "")
            aw.setLargeImage1(image)

            imageFound = 1


    # Find Title
    tag = "\"btAsinTitle\""

    if string.find(source, tag) == -1:
        tag = "id=\"productTitle\""

    if string.find(source, tag) == -1:
        # MP3 listing tag
        tag = "id=\"title_row\""
        aw.setFormat("MP3")

    if string.find(source, tag) == -1:
        # MP3 listing tag
        tag = "id=\"title_feature_div\""
        aw.setFormat("MP3")

    source = searchForPlus(source, tag)
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])
    aw.setTitle(title)


    # Find Artist
    tag = "field-artist"
    i = string.find(source, tag)

    if i == -1:
        tag = "field-keywords="
        i = string.find(source, tag)

    if i == -1:
        tag = "id=\"ProductInfoArtistLink\""
        i = string.find(source, tag)

    if i == -1:
        tag = " href=\"/"
        i = string.find(source, tag)

    if i != -1:
        artist = searchForPlus(source, tag)
        artist = searchForPlus(artist, ">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setArtist(artist)

    if title != "" and artist == "":
        print "Getting artist from <title>: ",titleartist
        aw.setArtist(titleartist)


    # Find Image
    if image == "":
        tag = "images.amazon.com"
        i = string.find(source, tag)

        if i == -1 or i > 3000:
            tag = "images-amazon.com/"
            i = string.find(source, tag)

        if i != -1 and i < 3000:
            image = source[i-50:]
            image = searchForPlus(image, " src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            image = string.replace(image, ".LZZZ", ".MZZZ")
            image = string.replace(image, ".TZZZ", ".MZZZ")

            i = string.find(image, "_PE")

            if i != -1:
                j = string.find(image[i+1:], "_")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "ZZZ")

            if i == -1:
                image = ""

        aw.setImage1(image)


    # find listprice
    i = string.find(source,"Preisempfehlung&#42;:&#160;<")

    if i != -1:
    	source = searchForPlus(source,"Preisempfehlung&#42;:&#160;<")
    	source = searchForPlus(source,">")
    	i = string.find(source,"<")
    	listprice = stripText(source[0:i])
        aw.setListPrice(listprice)

    # Find Price
    i = string.find(source, "Preis:<")

    if (i != -1):
        source = searchForPlus(source, "Preis:<")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        value = string.replace(value, "EUR", "")
        aw.setItemValue(value)
        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Categories
    category = ""
    i = string.find(source, ">hnliche Artikel finden<")

    if i != -1:
        cats = searchForPlus(source, ">hnliche Artikel finden<")
        cats = searchForPlus(cats, "<li>")
        i = string.find(cats, "</li>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=") != None):
            cats = searchForPlus(cats, "href=")
            cats = searchForPlus(cats, ">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Vorschau":
                continue

            if ccount == 1:
                aw.setCategory1(cat)
            elif ccount == 2:
                aw.setCategory2(cat)
            else:
                aw.setCategory3(cat)
                break

            ccount = ccount + 1


    # Find Format
    details = searchForPlus(source, ">Produktinformation<")
    i = string.find(details, "</ul>")
    details = stripText(details[0:i])

    while (searchFor(details, "<li>") != None):
        details = searchForPlus(details, "<li>")
        i = string.find(details, "</li>")
        temp = stripText(details[0:i])

        if temp.endswith(")") == 1:
            i = string.find(temp, "http:")

            if i != -1:
                continue

            i = string.find(temp, "<b>")

            if i != -1:
                temp = searchForPlus(temp, "<b>")
                i = string.find(temp, "<")
                format = stripText(temp[0:i])
                aw.setFormat(format)


                # Find Date
                i = string.find(temp, "(")
        
                if i <= 100:
                    temp = searchForPlus(temp, "(")
                    i = string.find(temp, ")")
                    date = stripText(temp[0:i])
                    aw.setReleaseDate(date)
            break


    # Find Composer
    i = string.find(source, ">Komponist:<")

    if i != -1:
        composer = searchForPlus(source, ">Komponist:<")
        composer = searchForPlus(composer, "\">")
        i = string.find(composer, "<")
        composer = stripText(composer[0:i])
        aw.setComposer(composer)


    # Find Conductor
    i = string.find(source, ">Conductor:<")

    if i != -1:
        conductor = searchForPlus(source, ">Conductor:<")
        conductor = searchForPlus(conductor, "\">")
        i = string.find(conductor, "<")
        conductor = stripText(conductor[0:i])
        aw.setConductor(conductor)


    # Find Label
    i = string.find(source, ">Label:<")

    if i != -1:
        label = searchForPlus(source, ">Label:<")
        label = searchForPlus(label, ">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Date (2nd attempt)
    i = string.find(source, ">Released:")

    if i != -1:
        source = searchForPlus(source, ">Released:")
        i = string.find(source, "<")
        date = stripText(source[0:i])
        aw.setReleaseDate(date)


    # Find Tracks
    i = string.find(source, "Titelverzeichnis")

    if i != -1:
        disks = searchForPlus(source, "Titelverzeichnis")
        i = string.find(disks, " <br>")
        disks = stripText(disks[0:i])
        i = string.find(disks, " Titel anzeigen.</a>")

        if i != -1:
            disks = stripText(disks[i-200:])
            disks = searchForPlus(disks, "<a href=\"")
            i = string.find(disks, "\">")
            url = "" + stripText(disks[0:i])
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            disks = http.getContents(url)
            disks = searchForPlus(disks, ">Titelverzeichnis <")
            i = string.find(disks, "<hr no")
            disks = stripText(disks[0:i])
            t2 = open(aw.getLogsDir() + "trace2.html", "w")
            t2.write(disks)
            t2.close()

        if string.find(disks, "Disk: ") == -1:
            disks = "Disk: 1" + disks

        diskCount = 0

        while (searchFor(disks, "Disk: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "Disk: ")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, "</table>")

            if i != -1:
                i = string.find(disks, "</table>")
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            trackCount = 0

            while (searchFor(tracks, ". ") != None):
                tracks = searchForPlus(tracks, ". ")

                if (tracks[0:1] == "<"):
                    i = string.find(tracks, "<A HREF=")

                    if i == 0:
                      i = string.find(tracks, ">")
                      tracks = stripText(tracks[i+1:])

                i = string.find(tracks, "<")

                if i != -1:
                    track = stripText(tracks[0:i])
                    i = string.find(track, ">")

                    if i != -1:
                        track = stripText(track[i+1:])

                    i = string.find(track, " - ")
                    artist = ""

                    if i != -1:
                        artist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                aw.setTrack(diskCount, trackCount, track, artist=artist)
                trackCount = trackCount + 1


    tag = ">Hrbeispiele<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Titelverzeichnis"
        i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        i = string.find(source, "<hr ")
        disks = stripText(source[0:i])
        i = string.find(disks, " Titel anzeigen.</a>")

        if i != -1:
            disks = stripText(disks[i-200:])
            disks = searchForPlus(disks, "<a href=\"")
            i = string.find(disks, "\">")
            url = "" + stripText(disks[0:i])
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            disks = http.getContents(url)
            disks = searchForPlus(disks, tag)
            i = string.find(disks, "<hr no")
            disks = stripText(disks[0:i])
            t2 = open(aw.getLogsDir() + "trace2.html", "w")
            t2.write(disks)
            t2.close()

        if string.find(disks, ">Disk: ") == -1:
            disks = ">Disk: 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disk: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disk: ")
            i = string.find(disks, "<")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])
            i = string.find(tracks, ">Disk: ")

            if i != -1:
                tracks = stripText(tracks[0:i])

            trackCount = 1

            while (searchFor(tracks, ". ") != None):
                tracks = searchForPlus(tracks, ". ")

                if (tracks[0:1] == "<"):
                    i = string.find(tracks, "<A HREF=")

                    if (i == 0):
                      i = string.find(tracks, ">")
                      tracks = stripText(tracks[i+1:])

                i = string.find(tracks, "<")

                if (i != -1):
                    track = stripText(tracks[0:i])
                    i = string.find(track, ">")

                    if (i != -1):
                        track = stripText(track[i+1:])

                    i = string.find(track, " - ")
                    artist = ""

                    if (i != -1):
                        atist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                aw.setTrack(diskCount, trackCount, track, artist=artist)
                tracks = tracks[i+1:]
                trackCount = trackCount + 1


    i = string.find(source, ">Reinhren und MP3s kaufen<")

    if i != -1:
        disks = searchForPlus(source, ">Reinhren und MP3s kaufen<")
        disks = searchForPlus(disks, "id='albumTrackList'")
        i = string.find(disks, "</DIV>")
        disks = stripText(disks[0:i])

        if string.find(disks, ">Disc ") == -1:
            disks = ">Disc 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")
            i = string.find(disks, "<")
            disks = searchForPlus(disks, "class=\"columnHeader\"")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            trackIndex = 1

            while (searchFor(tracks, "class=\"titleCol\"") != None):
                trackid = "%02d" % trackIndex
                tracks = searchForPlus(tracks, "class=\"titleCol\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                artist = ""
                i = string.find(tracks, "class=\"titleCol\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"titleCol\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                time = ""
                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])
                aw.setTrack(diskCount, trackIndex, track, artist=artist, time=time)

                trackIndex = trackIndex + 1


    # Find Tracks
    i = string.find(source, "id=\"dmusic_tracklist_player\"")

    if i != -1:
        tracks = searchForPlus(source, "id=\"dmusic_tracklist_player\"")
        i = string.find(tracks, "id=\"purchase-sims-feature\"")
        tracks = stripText(tracks[0:i])

        trackCount = 0

        while (searchFor(tracks, "\"dmusic_tracklist_track_title") != None):
            trackCount = trackCount + 1
            tracks = searchForPlus(tracks, "\"dmusic_tracklist_track_title")
            tracks = searchForPlus(tracks, " href=\"")
            tracks = searchForPlus(tracks, "\">")
            i = string.find(tracks, "<")
            title = stripText(tracks[0:i])

            if title == "Terms of Use":
                continue

            i = string.rfind(title, "(")

            if i >= 1:
                title = stripText(title[0:i])

            artist = ""
            i = string.find(tracks, "dmusic_tracklist_artist_name_")

            if i != -1:
                tracks = searchForPlus(tracks, "dmusic_tracklist_artist_name_")
                tracks = searchForPlus(tracks, " title=\"")
                i = string.find(tracks, "\"")
                artist = stripText(tracks[0:i])

            time = ""
            i = string.find(tracks, "id=\"dmusic_tracklist_duration")

            if i != -1:
                tracks = searchForPlus(tracks, "id=\"dmusic_tracklist_duration")
                tracks = searchForPlus(tracks, "<span ")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])

            aw.setTrack(1, trackCount, title, artist=artist, time=time)


    # Find Comments
    tag = ">Produktbeschreibungen<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Reviews<"
        i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<div")
        comments = searchForPlus(comments, ">")

        i = string.find(comments, "<div class=\"emptyClear\">")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<style ")

        if i != -1:
            comments = comments[0:i]

        aw.setProductInfo(comments)



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
